<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">


      <el-form-item label="单据编号" prop="billNumber">
        <el-input
          v-model="queryParams.billNumber"
          placeholder="请输入单据编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="出入库类型" prop="inoutType">
        <el-select v-model="queryParams.inoutType" placeholder="请选择出入库类型" clearable>
          <el-option
            v-for="dict in dict.type.sys_inbound_outbound_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="航次号" prop="voyageNo">
        <el-input
          v-model="queryParams.voyageNo"
          placeholder="请输入航次号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="船舶名称" prop="vesselName">
        <el-input
          v-model="queryParams.vesselName"
          placeholder="请输入船舶名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="货物名称" prop="cargoName">
        <el-input
          v-model="queryParams.cargoName"
          placeholder="请输入货物名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="仓库名称" prop="stockCode" class="search-item">
        <el-select v-model="queryParams.stockCode" filterable placeholder="请选择">
          <el-option v-for="dict in warehouses" :key="dict.stockCode" :label="dict.stockName" :value="dict.stockCode">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="仓位名称" prop="stockName" class="search-item">
        <el-select v-model="queryParams.stockName" filterable placeholder="请选择">
          <el-option v-for="dict in stockList" :key="dict.stockName" :label="dict.stockName" :value="dict.stockName">
          </el-option>
        </el-select>
      </el-form-item>
<!--      <el-form-item label="库场名称" prop="stockName">-->
<!--        <el-input-->
<!--          v-model="queryParams.stockName"-->
<!--          placeholder="请输入库场名称"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="业务性质" prop="opType">
        <el-select v-model="queryParams.opType" placeholder="请选择业务性质" clearable>
          <el-option
            v-for="dict in dict.type.sys_business_nature"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="贸易性质" prop="tradType">
        <el-select v-model="queryParams.tradType" placeholder="请选择贸易性质" clearable>
          <el-option
            v-for="dict in dict.type.sys_trade_nature"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="报关单号" prop="customsNo">
        <el-input
          v-model="queryParams.customsNo"
          placeholder="请输入报关单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="核注清单号" prop="listNumber" >
        <el-input
          v-model="queryParams.listNumber"
          placeholder="请输入核注清单号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="单据日期" prop="queryTime">
        <el-date-picker clearable
                        v-model="queryTime"
                        size="small"
                        :picker-options="pickerOptions"
                        end-placeholder="结束日期"
                        range-separator="-" start-placeholder="开始日期" type="daterange"
                        value-format="yyyy-MM-dd"
                        placeholder="请选择单据日期">
        </el-date-picker>
      </el-form-item>

      <el-form-item label="有效期至" prop="queryTime">
        <el-date-picker clearable
                        v-model="queryTimeTwo"
                        size="small"
                        :picker-options="pickerOptions"
                        end-placeholder="结束日期"
                        range-separator="-" start-placeholder="开始日期" type="daterange"
                        value-format="yyyy-MM-dd"
                        placeholder="请选择有效期至">
        </el-date-picker>
      </el-form-item>


      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">

      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['jxc:ckcargo:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" highlight-current-row :data="ckcargoList" @sort-change="handleSortChange"
              @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
        <el-table-column label="HS编号" align="center" prop="hsCode" sortable='custom' width="100"/>
        <el-table-column label="货物名称" align="center" prop="cargoName" sortable='custom' width="100"/>
      <el-table-column label="规格类型品质" align="center" prop="cargoSpec" sortable='custom' width="130"/>
      <el-table-column label="原产国" align="center" prop="originCountry" sortable='custom' width="100"/>
      <el-table-column label="仓库名称" align="center" prop="stockCode" sortable='custom' width="120">
        <template slot-scope="scope">
          <WarehouseName :stockCode="scope.row.stockCode"/>/{{scope.row.stockName}}
        </template>
      </el-table-column>
        <el-table-column label="单据日期" align="center" prop="billDate" width="180" sortable='custom'>
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.billDate, '{y}-{m}-{d} {h}:{i}:{s}') }}</span>
          </template>
        </el-table-column>
      <el-table-column label="入库重量" align="center" prop="cargoWt" sortable='custom' width="130">
        <template slot-scope="scope">
          {{scope.row.inoutType == '1' ? scope.row.cargoWt : ''}}
        </template>
      </el-table-column>
      <el-table-column label="出库重量" align="center" prop="cargoWt" sortable='custom' width="130">
        <template slot-scope="scope">
          {{scope.row.inoutType == '2' ? scope.row.cargoWt : ''}}
        </template>
      </el-table-column>
      <el-table-column label="航次号" align="center" prop="voyageNo" sortable='custom' width="100"/>
      <el-table-column label="船舶名称" align="center" prop="vesselName" sortable='custom' width="100"/>
    </el-table>

    <pagination

      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />


  </div>
</template>

<script>
import {pageListCkcargo, getCkcargo, delCkcargo, addCkcargo, updateCkcargo, queryCkcargo} from "@/api/jxc/ckcargo";
import {listWarehouse} from "@/api/jxc/warehouse";
import {listStock} from "@/api/jxc/stock";



export default {
  name: "Total",
  dicts: ['sys_business_nature', 'sys_trade_nature', 'sys_inbound_outbound_type'],
  data() {
    return {
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },

      activeName: ['1', '2', '3'],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 选中名字
      names: [],
      // 非单个禁用
      single: true,
      // 仓库表格数据
      stockList: [],
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      ckcargoList:[],
      // 总条数
      total: 0,
      // 有效期
      queryTimeTwo: [],
      // 单据时间
      queryTime: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 仓库名称数据
      warehouses: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
        beginDate: null,
        endDate: null,
        beginDateTwo: null,
        endDateTwo: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {

      }
    };
  },
  created() {
    this.getStockList();

    this.getList();
    listWarehouse({}).then(response => {
      this.warehouses = response.data;
    });
  },
  methods: {
    //仓库
    setStockDetail(stockId) {
      console.log(stockId);
      this.stockList.forEach(ele => {
        if (ele.id == stockId) {
          console.log("aa:",ele.stockName);
          this.form.stockName = ele.stockName;
          this.form.stockCode = ele.stockCode;
        }
      })
    },

    getStockList() {
      let param = {};
      listStock(param).then(response => {
        this.stockList = response.data;
      }).catch(e => {
      });
    },
    /** 查询出入库单据明细列表 */
    getList() {
      this.loading = true;
      if(this.queryTime!=null){
        this.queryParams.beginDate=this.queryTime[0];
        this.queryParams.endDate=this.queryTime[1];
      }else{
        this.queryParams.beginDate=null;
        this.queryParams.endDate=null;
      }
      if(this.queryTimeTwo!=null){
        this.queryParams.beginDateTwo=this.queryTimeTwo[0];
        this.queryParams.endDateTwo=this.queryTimeTwo[1];
      }else{
        this.queryParams.beginDateTwo=null;
        this.queryParams.endDateTwo=null;
      }
      queryCkcargo(this.queryParams).then(response => {
        this.ckcargoList = response.rows;
        this.total = response.total;
        this.loading = false;
      }).catch(e => {
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        billId: null,
        billDate: null,
        billNumber: null,
        inoutType: null,
        voyageId: null,
        voyageNo: null,
        vesselId: null,
        vesselName: null,
        cargoId: null,
        hsCode: null,
        cargoName: null,
        billNo: null,
        cargoSpec: null,
        originCountry: null,
        custId: null,
        custName: null,
        opType: null,
        tradType: null,
        cargoNum: null,
        cargoWt: null,
        cargoVol: null,
        stockId: null,
        stockCode: null,
        stockName: null,
        remark: null,
        cargoValue:null,
        customsNo:null,
        listNumber:null,
      };
      this.resetForm("form");
    },
    //排序
    handleSortChange(col) {
      this.$sortBy(col, this.queryParams);
      this.getList();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.queryTime = [];
      this.queryTimeTwo = [];

      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.names = selection.map(item => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加出入库单据明细";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getCkcargo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改出入库单据明细";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCkcargo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCkcargo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.id || this.names;
      this.$modal.confirm('是否确认删除"' + row.billNumber  + '"的数据项？').then(function () {
        return delCkcargo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('jxc/ckcargo/export', {
        ...this.queryParams
      }, `出入库单据明细_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
